library amzip;

uses Windows,
  spi_api, zipheader, zlibpas;

{$E .spi}

const
  Version = '0.3 (zlib '+ZLIB_VERSION+')';
  PluginInfo: array[0..3] of PChar = (
    '00AM',
    'ZIP extract library ver'+Version+' (C)Ferdia',
    '*.zip',
    'ZIP file(*.zip)'
  );

type
  PSign = ^TSign;
  TSign = array[0..3] of Char;

function DosTimeTotime_t(DosDate, DosTime: Word): Integer;
var
  lft, ft: TFileTime;
begin
  DosDateTimeToFileTime(DOSDate, DOSTime, lft);
  LocalFileTimetoFileTime(lft, ft);
  // Trunc((1970-1601)*365.2425)*24*60*60 = 11644473600
  Result := Trunc(Comp(ft) / 10000000.0 - 11644473600.0);
end;

// ΃pX\LPathfBNgƃt@Cɕ
// pX؂'/''\'ɕϊ('\'łȂsusie摜WJłȂ)
procedure SplitPath(Path: string; var Head, Tail: string);
var
  i, dpos: Integer;
begin
  dpos := 0;
  i := 0;
  while i < Length(Path) do
  begin
    Inc(i);
    if IsDBCSLeadByte(Byte(Path[i])) then
      Inc(i)
    else if Path[i] in ['\', '/'] then
    begin
      Path[i] := '\';
      dpos := i;
    end;
  end;
  Head := Copy(Path, 1, dpos); // \͂Ă
  Tail := Copy(Path, dpos+1, Length(Path)-dpos);
end;

// End of Cental DirTăt@C|C^Zbg
// (t@C64KB܂ł̂ڂ)
function FindEndOfCentralDir(HFile: THandle): Boolean;
var
  sign: TSign;
  readbytes: DWORD;
  totalread: Integer;
  readbuf: string;
  idx: Integer;
begin
  SetFilePointer(HFile, -(SizeOf(sign)+SizeOf(TEndOfCentralDirectory)), nil, FILE_END);
  ReadFile(HFile, sign, SizeOf(sign), readbytes, nil);
  if readbytes < SizeOf(sign) then
  begin
    Result := False;
    Exit;
  end;

  if sign = ZIP_END_CENTRALDIR_HEADER_SIGN then
  begin
    Result := True;
    Exit;
  end;

  totalread := 0;
  SetLength(readbuf, 1024*8);
  while True do
  begin
    SetFilePointer(HFile, -Length(readbuf), nil, FILE_CURRENT);
    FillChar(readbuf[1], Length(readbuf), 0);
    ReadFile(HFile, readbuf[1], Length(readbuf), readbytes, nil);
    Inc(totalread, readbytes);
    idx := Pos(ZIP_END_CENTRALDIR_HEADER_SIGN, readbuf);
    if idx > 0 then
    begin
      SetFilePointer(HFile, -readbytes+idx-1+SizeOf(sign), nil, FILE_CURRENT);
      Result := True;
      Exit;
    end;

    if (readbytes < DWORD(Length(readbuf))) or (totalread > 65535) then
    begin
      Result := False;
      Exit;
    end;

    // ESignatureꍇl4bytesԂ点ēǂ
    SetFilePointer(HFile, -Length(readbuf)+SizeOf(sign), nil, FILE_CURRENT);
  end;
end;

function ReadZipFileHeader(hfile: THandle; var Header: TZipFileHeader): Boolean;
var
  sign: TSign;
  readbytes: DWORD;
begin
  sign := '';
  ReadFile(HFile, sign, SizeOf(sign), readbytes, nil);
  if sign <> ZIP_FILE_HEADER_SIGN then
  begin
    Result := False;
    Exit;
  end;

  ReadFile(HFile, Header, SizeOf(Header), readbytes, nil);
  if readbytes < SizeOf(Header) then
  begin
    Result := False;
    Exit;
  end;

  Result := True;
end;

function Decompress(InBuf: PChar; InBufSize: Cardinal;
  OutBuf: PChar; OutBufSize: Cardinal): Integer;
var
  zs: z_stream;
begin
  FillChar(zs, SizeOf(z_stream), 0);
  zs.next_in := InBuf;
  zs.avail_in := InBufSize;
  zs.next_out := OutBuf;
  zs.avail_out := OutBufSize;
  Result := inflateInit2(zs, -15);
  if Result < Z_OK then
    Exit;
  try
    Result := inflate(zs, Z_NO_FLUSH);
  finally
    inflateEnd(zs);
  end;
end;


{ Plugin Functions }

function GetPluginInfo(infono: Integer; buf: PChar; buflen: Integer): Integer; stdcall;
begin
  if (infono < 0) or (infono > High(PluginInfo)) then
    Result := 0
  else begin
    lstrcpyn(buf, PluginInfo[infono], buflen);
    Result := lstrlen(buf);
  end;
end;

function IsSupported(filename: LPSTR; dw: DWORD): Integer; stdcall;
var
  sign: TSign;
  readbytes: DWORD;
begin
  if (dw and $FFFF0000) = 0 then
  begin
    if not ReadFile(dw, sign, SizeOf(sign), readbytes, nil) then
    begin
      Result := 0;
      Exit;
    end;
  end else
    sign := PSign(dw)^;

  if sign = ZIP_FILE_HEADER_SIGN then
    Result := 1
  else
    Result := 0
end;

// t@CT̂len͖
function GetArchiveInfo(buf: LPSTR; len: Longint; flag: unsigned_int;
  var hinf: HLOCAL): Integer; stdcall;
var
  hfile : THandle;
  sign: TSign;
  ecdir: TEndOfCentralDirectory;
  readbytes : DWORD;
  ofs: Integer;
  filecount : Integer;
  cdir: TCentralDirectory;
  htmp: HLOCAL;
  fname, head, tail: string;
  info : PFileInfo;
begin
  if (flag and 7) <> 0 then //͖Ή
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  hfile := CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if hfile = INVALID_HANDLE_VALUE then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;

  try
    if not FindEndOfCentralDir(hfile) then
    begin
      Result := SPI_ERROR_BROKEN_DATA;
      Exit;
    end;

    ReadFile(hfile, ecdir, SizeOf(ecdir), readbytes, nil);

    // End of Central DirɋL^ĂCentral Dir̃TCYvZ
    // Central DirJnʒu End of Central DirɋL^ĂJnʒu
    // Local FilẽItZbgɑ(ɃS~Ăꍇ̑΍)
    // (ԂunzipƓ)
    // (łɃS~ĂIsSupportedł͂Ă܂)
    ofs := Integer(SetFilePointer(hfile, -(SizeOf(sign)+SizeOf(ecdir)+ecdir.SizeCentralDir),
      nil, FILE_CURRENT)) - ecdir.OffsetStartCentralDir;

    hinf := LocalAlloc(LHND, SizeOf(TFileInfo));
    if hinf = 0 then
    begin
      Result := SPI_ERROR_ALLOCATE_MEMORY;
      Exit;
    end;

    filecount := 0;
    while True do
    begin
      ReadFile(hfile, sign, SizeOf(sign), readbytes, nil);
      if (readbytes < SizeOf(sign)) or (sign <> ZIP_CENTRALDIR_HEADER_SIGN) then
        Break;

      ReadFile(hfile, cdir, SizeOf(cdir), readbytes, nil);
      Inc(filecount);

      htmp := LocalRealloc(hinf, SizeOf(TFileInfo)*(filecount+1),
        LMEM_MOVEABLE or LMEM_ZEROINIT);
      if htmp = 0 then
      begin
        LocalFree(hinf);
        Result := SPI_ERROR_ALLOCATE_MEMORY;
        Exit;
      end else
        hinf := htmp;

      SetLength(fname, cdir.FileNameLen);
      ReadFile(hfile, fname[1], cdir.FileNameLen, readbytes, nil);
      info := LocalLock(hinf);
      Inc(info, FileCount-1);
      case cdir.Method of
        0: info.method := 'Stored';
        Z_DEFLATED: info.method := 'Deflate';
      end;
      info.position := cdir.LocalHeaderOffset + ofs;
      info.compsize := cdir.CompSize;
      info.filesize := cdir.UnCompSize;
      info.timestamp := DosTimeTotime_t(cdir.FileMDate, cdir.FileMTime);
      info.CRC := cdir.Crc;
      SplitPath(fname, head, tail);
      lstrcpyn(info.path, PChar(head), SizeOf(info.path));
      lstrcpyn(info.filename, PChar(tail), SizeOf(info.filename));
      LocalUnLock(hinf);
      SetFilePointer(hfile, cdir.ExtraFieldLen+cdir.FileCommentLen, nil, FILE_CURRENT);
    end;
    Result := SPI_ERROR_SUCCESS;
  finally
    CloseHandle(hfile);
  end;
end;

function GetFileInfo(buf: LPSTR; len: Longint; filename: LPSTR; flag: unsigned_int;
  var Info: TFileInfo): Integer; stdcall;
var
  hfile : THandle;
  readbytes : DWORD;
  header: TZipFileHeader;
  fname, head, tail: string;
begin
  if (flag and 7) <> 0 then //͖Ή
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  hfile := CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if hfile = INVALID_HANDLE_VALUE then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;
  
  try
    SetFilePointer(hfile, len, nil, FILE_BEGIN); // ItZbgV[N

    if not ReadZipFileHeader(hfile, header) then
    begin
      Result := SPI_ERROR_BROKEN_DATA;
      Exit;
    end;

    SetLength(fname, header.FileNameLen);
    ReadFile(hfile, fname[1], header.FileNameLen, readbytes, nil);

    case header.Method of
      0: Info.method := 'Stored';
      Z_DEFLATED: Info.method := 'Deflate';
    end;
    Info.position := len;
    Info.compsize := header.CompSize;
    Info.filesize := header.UnCompSize;
    Info.timestamp := DosTimeTotime_t(header.FileMDate, header.FileMTime);
    Info.CRC := header.Crc;
    SplitPath(fname, head, tail);
    lstrcpyn(Info.path, PChar(head), SizeOf(Info.path));
    lstrcpyn(Info.filename, PChar(tail), SizeOf(Info.filename));

    Result := SPI_ERROR_SUCCESS;
  finally
    CloseHandle(hfile);
  end;
end;

function GetFile(src: LPSTR; len: Longint; dest: LPSTR; flag: unsigned_int;
  ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
var
  hfile : THandle;
  readbytes : DWORD;
  header: TZipFileHeader;
  phmem : PHandle;
  inbuf, outbuf: PChar;
begin
  //t@Co, ͖Ή
  if ((flag and $700) = 0) or ((flag and 7) <> 0) then
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  if Assigned(ProgressCallBack) then
  begin
    if ProgressCallBack(0, 100, lData) <> 0 then
    begin
      Result := SPI_ERROR_CANCEL_EXPAND;
      Exit;
    end;
  end;

  hfile := CreateFile(src, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if hfile = INVALID_HANDLE_VALUE then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;

  try
    SetFilePointer(hfile, len, nil, FILE_BEGIN); // ItZbgV[N

    if not ReadZipFileHeader(hfile, header) then
    begin
      Result := SPI_ERROR_BROKEN_DATA;
      Exit;
    end;

    phmem := PHandle(dest);
    phmem^ := LocalAlloc(LMEM_MOVEABLE, header.UnCompSize);
    if phmem^ = HLOCAL(nil) then
    begin
      Result := SPI_ERROR_ALLOCATE_MEMORY;
      Exit;
    end;

    SetFilePointer(hfile, header.FileNameLen+header.ExtraFieldLen, nil, FILE_CURRENT);
    inbuf := nil;
    GetMem(inbuf, header.CompSize);
    if inbuf = nil then
    begin
      Result := SPI_ERROR_ALLOCATE_MEMORY;
      Exit;
    end;

    // check error?
    ReadFile(hfile, inbuf^, header.CompSize, readbytes, nil);
  finally
    CloseHandle(hfile);
  end;
  
  outbuf := LocalLock(phmem^);
  try
    if header.Method = 0 then // Stored
      Move(inbuf^, outbuf^, header.UnCompSize)
    else begin // Deflate
      if Decompress(inbuf, header.CompSize, outbuf, header.UnCompSize) < Z_OK then
      begin
        Result := SPI_ERROR_BROKEN_DATA;
        Exit;
      end;
    end;
  finally
    LocalUnLock(phmem^);
    FreeMem(inbuf);
  end;

  if Assigned(ProgressCallBack) then
  begin
    if ProgressCallBack(100, 100, lData) <> 0 then
    begin
      Result := SPI_ERROR_CANCEL_EXPAND;
      Exit;
    end;
  end;

  Result := SPI_ERROR_SUCCESS;
end;

{
// Plug-inݒ_CAO\
function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;
begin
  Result := SPI_ERROR_NOT_IMPLEMENTED;
end;
}

exports
  //ConfigurationDlg,
  GetPluginInfo,
  IsSupported,
  GetArchiveInfo,
  GetFileInfo,
  GetFile;

begin
  IsMultiThread := True;
end.

