unit zipheader;

interface

const
  ZIP_FILE_HEADER_SIGN = 'PK'#03#04;
  ZIP_EXTENDED_HEADER_SIGN = 'PK'#07#08;
  ZIP_CENTRALDIR_HEADER_SIGN = 'PK'#01#02;
  ZIP_END_CENTRALDIR_HEADER_SIGN = 'PK'#05#06;

type
  PZipFileHeader = ^TZipFileHeader;
  TZipFileHeader = packed record
    VersionNeeded: Word;
    Flag: Word;
    Method: Word;
    FileMTime: Word;
    FileMDate: Word;
    Crc: Longint;
    CompSize: Longint;
    UnCompSize: Longint;
    FileNameLen: Word;
    ExtraFieldLen: Word;
  end;

  TZipExtendedHeader = packed record
    Crc: Longint;
    CompSize: Longint;
    UnCompSize: Longint;
  end;

  TCentralDirectory = packed record
    VersionMadeBy: Word;
    VersionNeeded: Word;
    Flag: Word;
    Method: Word;
    FileMTime: Word;
    FileMDate: Word;
    Crc: Longint;
    CompSize: Longint;
    UnCompSize: Longint;
    FileNameLen: Word;
    ExtraFieldLen: Word;
    FileCommentLen: Word;
    DiskNumberStart: Word;
    InternalFileAttr: Word;
    ExternalFileAttr: Longint;
    LocalHeaderOffset: Longint;
  end;

  TEndOfCentralDirectory = packed record
    NumThisDisk: Word;
    NumDiskStartDir: Word;
    NumEntriesCentralDirThisDisk: Word;
    TotalEntriesCentralDir: Word;
    SizeCentralDir: Longint;
    OffsetStartCentralDir: Longint;
    ZipFileCommentLen: Word;
  end;

implementation

end.
